#include <bits/stdc++.h>

using namespace std;

int cnt[30];
int rem[30];

bool check()
{
    bool b1 = true,b2 = true;
    for(int i = 0;i<29;i++)
    {
        if(cnt[i] < rem[i])
            b1 = false;
    }
    for(int i = 0;i<29;i++)
    {
        if(rem[i] < cnt[i])
            b2 = false;
    }
    return b1 || b2;
}

void testOut()
{
    for(int i = 0;i<3;i++)
        cout << cnt[i] << " ";
    cout << endl;
    for(int i = 0;i<3;i++)
        cout << rem[i] << " ";
    cout << endl << endl;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    string s;
    cin >> s;

    while(s.size() != 0 && s[0] == s[s.size()-1])
    {
        s.erase(s.begin());
        if(s.size() != 0)
            s.erase(s.end()-1);
    }
    if(s.size() == 0)
    {
        cout << 1 << endl;
        return 0;
    }

    cnt[s[0]-'a']++;
    for(int i = 1;i<s.size();i++)
    {
        rem[s[i]-'a']++;
    }
    int res = s.size();
    for(int i = 1;i<s.size();i++)
    {
        //testOut();

        if(check())
        {
            int t = s.size()-i;
            res = min(res,max(i,t));
        }
        cnt[s[i]-'a']++;
        rem[s[i]-'a']--;
    }

    cout << res << endl;
    //cout << s;

    return 0;
}